#!/bin/bash
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 12 january 2014
#
# where you have store the script and the awk-program
DIR=./
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
list=`ls ${WHERE}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      if [ -a ".no_coding_style" ] ;
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] ;
      then
        # do not explore the next directory(ies)
        touch .no_recursion
      else
        cd ${eachFile}
        liste=`ls -1A`
        for file_1 in ${liste}
        do
          ${nameOfTheScript} ${file_1}
        done
        cd ..
      fi
    fi
  else
    if [ ! -f ${eachFile} ] ;
    then
      echo "no such file "${eachFile}
      exit
    fi
    # Is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      gawk -f ${DIR}/Public.awk -v mode=check < ${eachFile} > coding-style-Public.tmp
      if [ -s coding-style-Public.tmp ] ;
      then
        echo "check the file "`pwd`/${eachFile}
        cat coding-style-Public.tmp
      fi
      rm coding-style-Public.tmp
    fi
  fi
done
